unit main;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, ExtCtrls, StdCtrls, MMSystem;

type

  { TFormAppli }

  TFormAppli = class(TForm)
    BtnRejouer: TButton;
    BtnQuit: TButton;
    BtnOk: TButton;
    ImgList1: TImageList;
    ImgLev0: TImage;
    ImgLev1: TImage;
    ImgFond: TImage;
    Img1: TImage;
    Img2: TImage;
    Img3: TImage;
    LbInfo: TLabel;
    LblCred: TLabel;
    LbCredit: TLabel;
    Pan1: TPanel;
    Tempo1: TTimer;
    Tempo2: TTimer;
    Tempo3: TTimer;
    Tempo4: TTimer;
    Tempo5: TTimer;
    Tempo6: TTimer;
    Tempo7: TTimer;
    Tempo8: TTimer;
    procedure BtnOkClick(Sender: TObject);
    procedure Calcul(Sender: TObject);
    procedure Essai(Sender: TObject);
    procedure BtnQuitClick(Sender: TObject);
    procedure BtnRejouerClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure ImgLev0MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ImgLev0MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ImgLev1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ImgLev1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Tempo1Timer(Sender: TObject);
    procedure Tempo2Timer(Sender: TObject);
    procedure Tempo3Timer(Sender: TObject);
    procedure Tempo4Timer(Sender: TObject);
    procedure Tempo5Timer(Sender: TObject);
    procedure Tempo6Timer(Sender: TObject);
    procedure Tempo7Timer(Sender: TObject);
    procedure Tempo8Timer(Sender: TObject);

  private
    x, y, somme, w, credit, a, b, c : Integer;
    tps, cred, gain, r, s, t, u : String;

  public

  end;

var
  FormAppli: TFormAppli;

implementation

{$R *.lfm}

{ TFormAppli }

procedure TFormAppli.Calcul(Sender: TObject);
begin  //Calcul gain crédit
  x:= StrToInt(gain);
  y:= StrToInt(cred);
  somme:= x+y;
  LblCred.Caption:= IntToStr(somme);
  gain:= '';
end;

procedure TFormAppli.BtnOkClick(Sender: TObject);
begin
  BtnQuit.Enabled:= True; //Active le bouton Quitter
  ImgLev0.Enabled:= True; //Active le levier
  tps:='1';
  LblCred.Caption:='10'; //Pour jouer 10 fois
  //Premières images visibles
  ImgList1.GetBitmap(0,Img1.Picture.Bitmap);
  ImgList1.GetBitmap(1,Img2.Picture.Bitmap);
  ImgList1.GetBitmap(2,Img3.Picture.Bitmap);
  Pan1.Hide; //Cache l'information
end;

procedure TFormAppli.Essai(Sender: TObject);
begin
  w:= StrToInt(LblCred.Caption);
  credit:= w-1;
  Case w of
    0 : Exit; //Neutralise l'action du levier dès que plus de crédit
    1 : BtnRejouer.Show; //Montre le bouton rejouer pour lancer une nouvelle partie
  end;
  LblCred.Caption:= IntToStr(credit); //Lien avec le calcul du crédit
  cred:= LblCred.Caption; //Idem
  Tempo1.Enabled:= True; //Lance la rotation des images
  Tempo1.Interval:= StrToInt(tps) * 100; //Vitesse de rotation selon tempo 1/10 de seconde
  PlaySound('Sonrotat.wav',0,SND_ASYNC);
end;

procedure TFormAppli.BtnQuitClick(Sender: TObject); //Ferme l'application
begin
  Close;
end;

procedure TFormAppli.BtnRejouerClick(Sender: TObject); //Réalimente le crédit et relance une partie
begin
  if LblCred.Caption='0' then
    LblCred.Caption:='10'; //Pour jouer 10 fois
  BtnRejouer.Hide; //Bouton Rejouer caché
end;

procedure TFormAppli.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
  Application.Terminate; //Fermeture de l'application
end;

procedure TFormAppli.FormCreate(Sender: TObject);
begin
  ImgLev1.Enabled:= False; //Levier figé
end;

procedure TFormAppli.ImgLev0MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  ImgLev0.Visible:=False; //Levier en position initiale cachée
  ImgLev1.Visible:=True; //Levier en position tirée visible
end;

procedure TFormAppli.ImgLev0MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  ImgLev0.Visible:=True; //Levier en position initiale visible
  ImgLev1.Visible:=False; //Levier en position tirée cachée
  essai(Self); //Lancement d'un essai
end;

procedure TFormAppli.ImgLev1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  ImgLev1.Visible:=True; //Levier en position tirée visible
  ImgLev0.Visible:=False; //Levier en position initiale cachée
end;

procedure TFormAppli.ImgLev1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  ImgLev1.Visible:=False; //Levier en position tirée cachée
  ImgLev0.Visible:=True; //Levier en position initiale visible
  essai(Self); //Lancement d'un essai
end;

procedure TFormAppli.Tempo1Timer(Sender: TObject); //Rotation 1 des images selon tempo
begin
  ImgList1.GetBitmap(1,Img1.Picture.Bitmap);
  ImgList1.GetBitmap(2,Img2.Picture.Bitmap);
  ImgList1.GetBitmap(3,Img3.Picture.Bitmap);
  Tempo2.Enabled:= True;
  Tempo2.Interval:= strtoint(tps) * 100;
  Tempo1.Enabled:= False;
end;

procedure TFormAppli.Tempo2Timer(Sender: TObject); //Rotation 2 des images selon tempo
begin
  ImgList1.GetBitmap(2,Img1.Picture.Bitmap);
  ImgList1.GetBitmap(3,Img2.Picture.Bitmap);
  ImgList1.GetBitmap(4,Img3.Picture.Bitmap);
  Tempo3.Enabled:= True;
  Tempo3.Interval:= strtoint(tps) * 100;
  Tempo2.Enabled:= False;
end;

procedure TFormAppli.Tempo3Timer(Sender: TObject); //Rotation 3 des images selon tempo
begin
  ImgList1.GetBitmap(3,Img1.Picture.Bitmap);
  ImgList1.GetBitmap(4,Img2.Picture.Bitmap);
  ImgList1.GetBitmap(5,Img3.Picture.Bitmap);
  Tempo4.Enabled:= True;
  Tempo4.Interval:= strtoint(tps) * 100;
  Tempo3.Enabled:= False;
end;

procedure TFormAppli.Tempo4Timer(Sender: TObject); //Rotation 4 des images selon tempo
begin
  ImgList1.GetBitmap(4,Img1.Picture.Bitmap);
  ImgList1.GetBitmap(5,Img2.Picture.Bitmap);
  ImgList1.GetBitmap(6,Img3.Picture.Bitmap);
  Tempo5.Enabled:= True;
  Tempo5.Interval:= strtoint(tps) * 100;
  Tempo4.Enabled:= False;
end;

procedure TFormAppli.Tempo5Timer(Sender: TObject); //Rotation 5 des images selon tempo
begin
  ImgList1.GetBitmap(5,Img1.Picture.Bitmap);
  ImgList1.GetBitmap(6,Img2.Picture.Bitmap);
  ImgList1.GetBitmap(7,Img3.Picture.Bitmap);
  Tempo6.Enabled:= True;
  Tempo6.Interval:= strtoint(tps) * 100;
  Tempo5.Enabled:= False;
end;

procedure TFormAppli.Tempo6Timer(Sender: TObject); //Rotation 6 des images selon tempo
begin
  ImgList1.GetBitmap(6,Img1.Picture.Bitmap);
  ImgList1.GetBitmap(7,Img2.Picture.Bitmap);
  ImgList1.GetBitmap(0,Img3.Picture.Bitmap);
  Tempo7.Enabled:= True;
  Tempo7.Interval:= strtoint(tps) * 100;
  Tempo6.Enabled:= False;
end;

procedure TFormAppli.Tempo7Timer(Sender: TObject); //Rotation 7 des images selon tempo
begin
  ImgList1.GetBitmap(7,Img1.Picture.Bitmap);
  ImgList1.GetBitmap(0,Img2.Picture.Bitmap);
  ImgList1.GetBitmap(1,Img3.Picture.Bitmap);
  Tempo8.Enabled:= True;
  Tempo8.Interval:= strtoint(tps) * 100;
  Tempo7.Enabled:= False;
end;

procedure TFormAppli.Tempo8Timer(Sender: TObject); //Rotation 8 des images selon tempo et lancement tirage pseudo aléatoire des images
begin
  randomize;

  //Tirer et afficher les images en fonction du score Random
  a := Random(8); //Tirage de 0 à 7 pour rotation des 8 images
  s:= FloatToStr(a);
  ImgList1.GetBitmap(a,Img1.Picture.Bitmap);

  //Fonctionnement identique au précédent
  b := Random(8);
  t:= FloatToStr(b);
  ImgList1.GetBitmap(b,Img2.Picture.Bitmap);

  //Fonctionnement identique au précédent
  c := Random(8);
  u:= FloatToStr(c);
  ImgList1.GetBitmap(c,Img3.Picture.Bitmap);
  Tempo8.Enabled:= False;

  //Afficher le message, jouer le son et incrémenter le crédit quand c'est gagné
  r:=s+t+u;
    Case r of
      '000' : gain:= '20';
      '111' : gain:= '15';
      '444','555','777' : gain:= '10';
      '222','333','666' : gain:= '5';
    end;

  if gain <>'' then
    PlaySound('Songain.wav',0,SND_ASYNC);

    Case gain of
      '20' : ShowMessage('Vous avez gagné ! + 20 à votre crédit.');
      '15' : ShowMessage('Vous avez gagné ! + 15 à votre crédit.');
      '10' : ShowMessage('Vous avez gagné ! + 10 à votre crédit.');
      '5' : ShowMessage('Vous avez gagné ! + 5 à votre crédit.');
    end;

  if gain <>'' then
    Calcul(Self);

  if LblCred.Caption <>'0' then
    BtnRejouer.Hide; //Bouton Rejouer caché
end;

end.

